<template>
  <div class="order-tracking__container execution">
    <h2>Трекинг на маршруте {{ order.fromLocationName}} → {{ order.toLocationName }}</h2>

    <div class="execution__content">
      <div class="execution-content__title">
        Отслеживаемые ТС
        <div class="order-link" v-if="order.transportationOrder && order.parentOrderUuid && order.tripUuid">
          <i class="icon truck"></i>
          Заказ на перевозку
          <router-link :to="{name: 'order__item', params: {id: order.parentOrderUuid}, query:{tripUuid: order.tripUuid}}">{{order.transportationOrder}}</router-link>
        </div>
      </div>

      <div class="execution-content__info">
        <ob-input label="Номер ТС" :value="order.tractorNumber" disabled/>
        <ob-input label="Номер прицепа" :value="order.wagonNumber" disabled/>
        <ob-input label="Номер телефона водителя" :value="order.driverPhone" disabled/>
        <ob-input label="ФИО водителя" :value="order.driverFio" disabled/>
      </div>

      <div class="execution-content__title">
        Устройства трекинга
      </div>

      <div class="execution-content__devices">
        <div class="execution-content__device">
          <div class="execution-content__device-img">
            <svg width="32" height="54" fill="none" xmlns="http://www.w3.org/2000/svg"><path fill-rule="evenodd" clip-rule="evenodd" d="M26 3H6a3 3 0 00-3 3v3h26V6a3 3 0 00-3-3zM0 9v39a6 6 0 006 6h20a6 6 0 006-6V6a6 6 0 00-6-6H6a6 6 0 00-6 6v3zm29 33V12H3v30h26zM3 45v3a3 3 0 003 3h20a3 3 0 003-3v-3H3zm7-39.5A1.5 1.5 0 0111.5 4h9a1.5 1.5 0 010 3h-9A1.5 1.5 0 0110 5.5zM16 50a2 2 0 100-4 2 2 0 000 4z" fill="#004BC8"/></svg>
          </div>
          <div class="execution-content__device-desc">
            Мобильное приложение
            <span>
              {{ deviceStatus.appStatus }}
            </span>
            <span>
              {{ deviceStatus.appLastCoordDate }}
            </span>
          </div>
          <div class="execution-content__device-menu">
            <ObMenuDropdown :items="dropdownMenuMobileApp" position="start" />
          </div>
        </div>
        <div class="execution-content__device">
          <div class="execution-content__device-img">
            <svg width="32" height="54" fill="none" xmlns="http://www.w3.org/2000/svg"><path fill-rule="evenodd" clip-rule="evenodd" d="M26 3H6a3 3 0 00-3 3v42a3 3 0 003 3h20a3 3 0 003-3V6a3 3 0 00-3-3zM6 0a6 6 0 00-6 6v42a6 6 0 006 6h20a6 6 0 006-6V6a6 6 0 00-6-6H6zm18 8H8v16h16V8zM8 5a3 3 0 00-3 3v16a3 3 0 003 3h16a3 3 0 003-3V8a3 3 0 00-3-3H8zm.5 24.666a2.5 2.5 0 100 5 2.5 2.5 0 000-5zm-2.5 9.5a2.5 2.5 0 115 0 2.5 2.5 0 01-5 0zm2.5 4.5a2.5 2.5 0 100 5 2.5 2.5 0 000-5zm5-11.5a2.5 2.5 0 115 0 2.5 2.5 0 01-5 0zm2.5 4.5a2.5 2.5 0 100 5 2.5 2.5 0 000-5zm-2.5 9.5a2.5 2.5 0 115 0 2.5 2.5 0 01-5 0zm10-16.5a2.5 2.5 0 100 5 2.5 2.5 0 000-5zm-2.5 9.5a2.5 2.5 0 115 0 2.5 2.5 0 01-5 0zm2.5 4.5a2.5 2.5 0 100 5 2.5 2.5 0 000-5z" fill="#004BC8"/></svg>
          </div>
          <div class="execution-content__device-desc">
            GSM
            <span>
              {{ deviceStatus.gsmStatus }}
            </span>
            <span>
              {{ deviceStatus.gsmOperatorDate }}
            </span>
          </div>
          <div class="execution-content__device-menu">
            <ObMenuDropdown :items="dropdownMenuGSM" />
          </div>
        </div>
        <div class="execution-content__device">
          <div class="execution-content__device-img">
            <svg width="32" height="54" fill="none" xmlns="http://www.w3.org/2000/svg"><path fill-rule="evenodd" clip-rule="evenodd" d="M22 2a2 2 0 114 0v4h1a5 5 0 015 5v32a5 5 0 01-5 5h-1v4a2 2 0 11-4 0v-4h-4v4a2 2 0 11-4 0v-4h-4v4a2 2 0 11-4 0v-4H5a5 5 0 01-5-5V11a5 5 0 015-5h1V2a2 2 0 114 0v4h4V2a2 2 0 114 0v4h4V2zm5 7a2 2 0 012 2v32a2 2 0 01-2 2H5a2 2 0 01-2-2V11a2 2 0 012-2h22zM10.071 23.661h4.444V22H8v9.953h3.746c1.13-.009 2.035-.305 2.714-.889.684-.587 1.025-1.364 1.025-2.33 0-.962-.344-1.726-1.032-2.29-.683-.57-1.61-.855-2.782-.855h-1.6V23.66zm0 6.645v-3.063h1.682c.52.01.927.146 1.224.41.3.26.45.616.45 1.067 0 .483-.156.868-.47 1.155-.31.287-.728.43-1.252.43h-1.634zm8.978-6.645h4.443V22h-6.515v9.953h3.746c1.13-.009 2.035-.305 2.714-.889.684-.587 1.026-1.364 1.026-2.33 0-.962-.344-1.726-1.033-2.29-.683-.57-1.61-.855-2.782-.855h-1.6V23.66zm0 6.645v-3.063h1.681c.52.01.928.146 1.224.41.3.26.451.616.451 1.067 0 .483-.157.868-.472 1.155-.31.287-.727.43-1.25.43h-1.634z" fill="#004BC8"/></svg>
          </div>
          <div class="execution-content__device-desc">
            Бортовой блок
            <span>
              {{ deviceStatus.sealStatus }}
            </span>
            <span>
              {{ deviceStatus.sealLastCoordDate }}
            </span>
          </div>
        </div>
      </div>
    </div>

    <div class="order-tracking__events">
      <div class="order-tracking__events-title">
        <h2>События по заказу</h2>
        <app-button-toggle
          v-model="eventsState"
          leftValue="route"
          leftLabel="Маршрут"
          leftIcon="route"
          rightValue="table"
          rightLabel="Таблица"
          rightIcon="group-list"
        />
      </div>

      <template v-if="eventsState === 'route'">
        <div class="order-tracking__event">
          <order-event
            v-for="(item, index) in eventsOutOfLocation"
            :key="index"
            :data="item"
          />
        </div>
        <div class="order-tracking__route">
          <route-card :value="routeItems" />
        </div>
      </template>

      <template v-if="eventsState === 'table'">
        <div class="order-tracking__event order-tracking__event--table">
          <ob-table
            :items="tableItems"
            :columns="tableColumns"
            :functionalPanel="false"
            :tableLayoutFixed="false"
            :footerDisabled="true"
            data-qa="orderExecutionTable"
            ref="obTableExecution"
          >
            <template v-slot:address="{ data }">
              <i :class="['icon', data.item.type === 'FROM' ? 'route-loading' : 'route-unloading']"></i>
              {{data.item.address}}
            </template>
            <template v-slot:arrival="{ data }">
              {{ data.item.arrival.time }}
              <p>{{ data.item.arrival.date }}</p>
            </template>
            <template v-slot:etaPlan="{ data }">
              {{ data.item.etaPlan.time}}
              <p>{{ data.item.etaPlan.date}}</p>
            </template>
            <template v-slot:etaCurrent="{ data }">
              {{ data.item.etaCurrent.time}}
              <p>{{ data.item.etaCurrent.date}}</p>
            </template>
            <template v-slot:parking="{ data }">
              {{ data.item.parking.time}}
              <p>{{ data.item.parking.date}}</p>
            </template>
            <template v-slot:arrivePrr="{ data }">
              {{ data.item.arrivePrr.time}}
              <p>{{ data.item.arrivePrr.date}}</p>
            </template>
            <template v-slot:leavePrr="{ data }">
              {{ data.item.leavePrr.time}}
              <p>{{ data.item.leavePrr.date}}</p>
            </template>
          </ob-table>
        </div>
      </template>
    </div>

    <ob-modal
        ref="orderLinkModal"
        :title=orderLinkModalTitle
        size="medium"
        :is-show-controls="false"
    >
      <div class="order-link-modal__outer">
        <ob-input :value="orderLink" disabled />
        <div style="display: flex; flex-direction: column">
          <ob-tooltip
              :content="copyTooltipContent"
              :value="copyTooltipVisible"
              position="top-end"
              :append-to-body="true"
          >
          </ob-tooltip>
          <ob-button
              label="Сохранить"
              data-qa="btnCopyOrderLink"
              @click="copyOrderLink"
          >
          </ob-button>
        </div>
      </div>
      <ob-button
          label="Закрыть"
          data-qa="btnCopyOrderLink"
          @click="closeOrderLinkModal"
      />
    </ob-modal>

  </div>
</template>

<script>
  import api from '@/api';
  import state from '../../../pages/orderPage/state/tracking';
  import obInput from 'common-components/src/obComponents/obInput';
  import obButton from 'common-components/src/obComponents/obButton';
  import ObMenuDropdown from 'common-components/src/obComponents/obMenuDropdown';
  import obModal from "common-components/src/obComponents/obModal";
  import obTooltip from "common-components/src/obComponents/obTooltip";
  import orderEvent from './TrackingOrderEvent';
  import routeCard from './TrackingRouteCard';
  import appButtonToggle from '../../appButtonToggle';
  import obTable from 'common-components/src/obComponents/obTable';
  import {
    getAppStatus,
    getGSMStatus,
    getSealStatus,
  } from 'src/constants/trackingDeviceStatus';

  export default {
    name: 'ordertrackingExecution',

    components: {
      obInput,
      obButton,
      ObMenuDropdown,
      obModal,
      obTooltip,
      orderEvent,
      routeCard,
      appButtonToggle,
      obTable,
    },

    props: {
      uuid: {
        type: String,
      }
    },

    data() {
      return {
        eventsState: 'route',
        deviceStatus: {
          appStatus: '',
          appLastCoordDate: '',
          gsmStatus: '',
          gsmOperatorDate: '',
          sealStatus: '',
          sealLastCoordDate: '',
          mobileButtonActive: false,
          gsmButtonActive: false,
        },
        deviceStatusTimer: null,
        deviceStatusInterval: 10*1000,
        orderLink: null,
        copyTooltipVisible: false,
        copyTooltipContent: '',
      }
    },

    computed: {
      tableColumns() {
        return [
          {
            title: "Адрес",
            key: "address",
            slotName: "address"
          },
          {
            title: "Плановое прибытие",
            key: "arrival",
            slotName: "arrival"
          },
          {
            title: "ETA Плановое",
            key: "etaPlan",
            slotName: "etaPlan"
          },
          {
            title: "ETA Текущее",
            key: "etaCurrent",
            slotName: "etaCurrent"
          },
          {
            title: "Въезд на стоянку",
            key: "parking",
            slotName: "parking"
          },
          {
            title: "Въезд в зону ПРР",
            key: "arrivePrr",
            slotName: "arrivePrr"
          },
          {
            title: "Выезд из зоны ПРР",
            key: "leavePrr",
            slotName: "leavePrr"
          }
        ]
      },

      routeItems() {
        return {
          pointFrom: '',
          pointTo:'',
          items: this.order.locations.map((item, i) => {
            return {
              current: false,
              date: this.getDate(item.arrivalSlotStartDt),
              done: false,
              point: item.operationType === 'LOADING' ? 'from' : 'to',
              pointAddress: '',
              pointName: item.title,
              status: this.statusesMap[this.order.status],
              time: `${this.getTime(item.arrivalSlotStartDt)} — ${this.getTime(item.arrivalSlotEndDt)}`,
              type: "location",
              uuid: i,
              events: this.sortedEvents.filter(evt => evt.tripPointUuid && evt.tripPointUuid === item.tripPointUuid),
              parkingRadius: item.parkingRadius,
              targetRadius: item.targetRadius
            }
          })
        }
      },

      tableItems() {
        return this.order.locations.map(item => {
          return {
            address: item.title,
            arrival: {
              time: item.arrivalSlotStartDt && item.arrivalSlotEndDt ? `${this.getTime(item.arrivalSlotStartDt)} - ${this.getTime(item.arrivalSlotEndDt)}` : '-',
              date: item.arrivalSlotStartDt ? this.getDate(item.arrivalSlotStartDt) : '-'
            },
            type: item.operationType === 'LOADING' ? 'FROM' : 'TO',
            etaPlan: {
              time: item.etaPlanDt ? this.getTime(item.etaPlanDt) : '-',
              date: item.etaPlanDt ? this.getDate(item.etaPlanDt) : '-'
            },
            etaCurrent: {
              time: item.etaCurrentDt ? this.getTime(item.etaCurrentDt) : '-',
              date: item.etaCurrentDt ? this.getDate(item.etaCurrentDt) : '-'
            },
            parking: {
              time: item.arrivedAtParkingDt ? this.getTime(item.arrivedAtParkingDt) : '-',
              date: item.arrivedAtParkingDt ? this.getDate(item.arrivedAtParkingDt) : '-'
            },
            arrivePrr: {
              time: item.arrivedAtPrrDt ? this.getTime(item.arrivedAtPrrDt) : '-',
              date: item.arrivedAtPrrDt ? this.getDate(item.arrivedAtPrrDt) : '-'
            },
            leavePrr: {
              time: item.departuredFromPrrDt ? this.getTime(item.departuredFromPrrDt) :'-',
              date: item.departuredFromPrrDt ? this.getDate(item.departuredFromPrrDt) : '-'
            }
          }
        })
      },

      sortedEvents() {
        // сортировка this.order.events изменяет этот массив и вызывает перерасчет computed свойства
        // чтобы этого избежать копируем массив this.order.events
        const events = [...this.order.events];
        return events.sort((a, b) => (new Date(a.occurredAt)).valueOf() - (new Date(b.occurredAt)).valueOf() );
      },

      eventsOutOfLocation() {
        return this.sortedEvents.filter(evt => !evt.tripPointUuid);
      },

      order() {
        return state.order;
      },

      statusesMap() {
        return state.statusesMap;
      },

      orderLinkModalTitle() {
        return `Ссылка на заказ ${this.order.orderNumber} скопирована в буфер обмена`;
      },

      dropdownMenuMobileApp() {
        return [
          {
            title: 'Отправить SMS со ссылкой на МП',
            method: () => {
              this.callTrackingOrderAction('SEND_ORDER_LINK');
            },
            isDisabled: !this.deviceStatus.mobileButtonActive
          },
          {
            title: 'Скопировать ссылку на заказ МП',
            method: this.getOrderLink,
          },
        ]
      },
      dropdownMenuGSM() {
        return [
          {
            title: 'Отправить SMS на подключение',
            method: () => {
              this.callTrackingOrderAction('SEND_GSM_SMS');
            },
            isDisabled: !this.deviceStatus.gsmButtonActive
          },
        ]
      },
    },

    mounted() {
      this.getDeviceStatus();
    },

    methods: {
      getTime(date) {
        const temp = new Date(date);
        const hours = temp.getHours() + '';
        const minutes = temp.getMinutes() + '';
        return `${hours.padStart(2, 0)}:${minutes.padStart(2, 0)}`
      },

      addTime(date, count) {
        const temp = new Date(date);
        const hours = temp.getHours();
        const newHours = hours >= (24 - (count - 1)) ? `${count - (24 - hours)}` + '' : hours + count + '';
        const minutes = temp.getMinutes() + '';
        return `${newHours.padStart(2, 0)}:${minutes.padStart(2, 0)}`
      },

      getDate(date) {
        const temp = new Date(date);
        const year = temp.getFullYear();
        const month = temp.getMonth() + 1 + '';
        const day = temp.getDate() + '';
        return `${day.padStart(2, 0)}.${month.padStart(2, 0)}.${year}`;
      },

      async getOrderLink() {
        if (this.orderLink) {
          this.$refs.orderLinkModal.open();
        } else {
          try {
            const { link } = await api.orders.getOrderLink(this.$route.params.id);
            this.orderLink = link;
            this.$refs.orderLinkModal.open();
          } catch (e) {
            throw e;
          }
        }
      },

      closeOrderLinkModal() {
        this.copyTooltipVisible = false;
        this.$refs.orderLinkModal.close();
      },

      copyOrderLink() {
        const textarea = document.createElement('textarea');
        textarea.setAttribute('readonly', true);
        textarea.setAttribute('contenteditable', true);
        textarea.style.position = 'absolute';
        textarea.style.left = '-9999px';
        textarea.value = this.orderLink;
        document.body.appendChild(textarea);
        textarea.select();
        const successful = document.execCommand('copy');
        if (this.copyTooltipVisible) {
          this.copyTooltipVisible = false;
        }
        this.$nextTick(() => {
          if (successful) {
            this.copyTooltipContent = 'Ссылка сохранена в буфер обмена';
            this.copyTooltipVisible = true;
          }
          else {
            this.copyTooltipContent = 'Текст не может быть скопирован в буфер обмена';
            this.copyTooltipVisible = true;
          }
          textarea.remove();
        })
      },

      async getDeviceStatus() {
        try {
          const { data, status } = await api.orders.getDeviceStatus(this.uuid);
          if (status === 204) {
            this.$set(this, 'deviceStatus', {
              appStatus: '',
              appLastCoordDate: '',
              gsmStatus: '',
              gsmOperatorDate: '',
              sealStatus: '',
              sealLastCoordDate: '',
              mobileButtonActive: false,
              gsmButtonActive: false,
            })
          } else {
            const newStatus = {
              appStatus: getAppStatus(data.appStatus) || '—',
              appLastCoordDate: this.formatStatusDate(data.appLastCoordDate),
              gsmStatus: getGSMStatus(data.gsmStatus) || '—',
              gsmOperatorDate: this.formatStatusDate(data.gsmOperatorDate),
              sealStatus: getSealStatus(data.sealStatus) || '—',
              sealLastCoordDate: this.formatStatusDate(data.sealLastCoordDate),
              mobileButtonActive: data.mobileButtonActive === true,
              gsmButtonActive: data.gsmButtonActive === true,
            }
            this.$set(this, 'deviceStatus', newStatus);
          }
        } catch (e) {
          throw e;
        } finally {
          if (this.deviceStatusTimer) {
            clearInterval(this.deviceStatusTimer);
          }
          this.deviceStatusTimer = setInterval(() => {
            if (this.deviceStatusTimer) {
              this.getDeviceStatus();
            }
          }, this.deviceStatusInterval);
        }
      },

      formatStatusDate(date) {
        let str = '';
        if (date) {
          str = this.$options.filters.date(date, 'DD.MM.YYYY HH:mm');
        }
        return str;
      },

      async callTrackingOrderAction(action) {
        try {
          await api.orders.trackingOrderAction(this.$route.params.id, action);
          this.$notification({
            type: "system_notification_success",
            message: "Запрос на отправку SMS выполнен",
          });
        } catch (error) {
          if (error.status === 400) {
            this.$notification({
              type: "system_notification_error",
              message: "Заказ исполнен или отменен",
            });
          } else {
            this.$notification({
              type: "system_notification_error",
              message: "Ошибка при выполнении действия",
            });
          }
        }
      },
    },

    beforeDestroy () {
      if (this.deviceStatusTimer) {
        clearInterval(this.deviceStatusTimer);
        this.deviceStatusTimer = null;
      }
    },
  }
</script>

<style lang="scss" scoped>
@import '~common-components/src/static/css/variables';
@import '~common-components/src/static/css/mixins';

h2 {
  @include font-mixin(20px, 28px, 700, $style-black);
}

.execution__content {
  margin-top: 18px;
  padding: 20px;
  background: $light-lavender;
  border: 1px solid $obInput-border_blue;
  border-radius: 4px;
}

.execution-content__title {
  margin-bottom: 12px;
  display: flex;
  align-items: center;
  justify-content: space-between;
  @include font-mixin(16px, 20px, 400, $color-text-base);
}

.order-link {
  display: flex;
  align-items: center;

  .icon {
    margin-right: 5px;
    font-size: 24px;
    color: $color-blue-navy-blue;
  }

  a {
    margin-left: 5px;
    color: $color-blue-navy-blue;
    text-decoration: none;
  }
}

.execution-content__info {
  margin-bottom: 20px;
  display: flex;

  &::v-deep {
    .ob-input-container {
      flex: 0 1 147px;

      &:not(:last-child) {
        margin-right: 10px;
      }

      &:nth-child(3) {
        flex: 1 1 228px;
      }

      &:nth-child(4) {
        flex: 2 1 378px;
      }
    }

    .ob-input-wrap.--theme-default.--disabled {
      color: $color-text-base;
    }

    .ob-input-wrap.--theme-default.--disabled {
      background-color: $lavender;
      border-color: $cornflower-craiola;
    }
  }
}
.execution-content__devices {
  display: flex;
  justify-content: space-between;
  align-items: center;
}

.execution-content__device {
  display: flex;
  align-items: center;
  padding: 12px 10px 12px 16px;
  width: calc((100% - 20px) / 3);
  border: 1px solid $cornflower-craiola;
  border-radius: 4px;
  background-color: $lavender;
  @include font-mixin(14px, 18px, 400, $color-text-base);
}

.execution-content__device-desc {
  display: flex;
  flex-direction: column;
  justify-content: center;
  flex-grow: 1;
  padding: 0 16px;

  span {
    display: flex;
    align-items: center;
    margin: 0;
    @include font-mixin(12px, 18px, 400, #757884);

    i {
      color: $color-grey-span;
      margin-right: 8px;
    }

    &.active {
      color: $color-green-light;

      i {
        color: $color-green-light;
      }
    }
  }
}

.order-tracking__events {
  margin-top: 40px;
}

.order-tracking__events-title {
  display: flex;
  justify-content: space-between;
  align-items: center;
}

.order-tracking__event {
  margin-top: 26px;

  &--table {
    border: 1px solid $lavender;
    border-radius: 3px;

    .icon.route-loading {
      color: $diamond-orange-yellow;
      font-size: 14px;
    }

    .icon.route-unloading {
      color: $Green-700;
      font-size: 14px;
    }
  }
}

::v-deep {
  // .color-error {

  //   button {
  //     color: inherit;
  //   }
  // }

  .card-title {
    display: none;
  }

  thead.fixed tr th {
    border-top: none;
  }

  tr:last-child {
    border-bottom: none;
  }

  td:first-child {
    div {
      display: flex;
      align-items: center;
    }

    i {
      margin-right: 20px;
    }
  }
}

.td-container p {
  color: #9DA0AC;
}

.order-link-modal__outer {
  align-items: center;
  display: flex;
  margin-bottom: 40px;

  .ob-input-container {
    flex-grow: 1;
    padding-right: 10px;
  }
}
</style>
